Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 798468 - sys-kernel/genkernel: does not handle -lcrypt if sys-apps/busybox is built with sys-libs/libxcrypt[-static-libs] set as system libcrypt
Summary: sys-kernel/genkernel: does not handle -lcrypt if sys-apps/busybox is built wi...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Hosted Projects
Classification: Unclassified
Component: genkernel (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo Genkernel Maintainers
URL:
Whiteboard:
Keywords: InVCS
Depends on:
Blocks: libxcrypt-migration
  Show dependency tree
 
Reported: 2021-06-24 21:01 UTC by Marco Scardovi (scardracs)
Modified: 2021-07-15 11:21 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
genkernel.log.xz (genkernel.tar.xz,178.57 KB, application/x-xz)
2021-06-25 15:09 UTC, Marco Scardovi (scardracs)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Marco Scardovi (scardracs) 2021-06-24 21:01:21 UTC
Following [1] I have moved from libcrypt to libxcrypt and compilation were all good.
Unfortunately genkernel does not handle -lcrypt on busybox as valide if libxcrypt is used and fails to compile initramfs.

@Whissi and @sam already know about that but opening bug as tracker.


References:
[1] https://gist.github.com/thesamesam/a36ff15235f5cbe5004972f80f254123è1

P.S.
Unfortunately I don't have any genkernel.log because it was overwritten by the one made with libcrypt
Comment 1 Thomas Deutschmann gentoo-dev Security 2021-06-24 23:30:24 UTC
I tried to reproduce on a fully converted system but failed (which makes sense if new libxcrypt is a drop-in replacement). Furthermore, default busybox built by genkernel doesn’t even link against crypt.

The only failure I was able to force was in util-linux when forcefully deleting libxcrypt headers (=putting system into broken state).

Therefore I am currently suspecting that this bug report is invalid (i.e. problem was seen on a not fully converted system) and requesting full logs (genkernel.log & `energe —info sys-lib/glibc libxcrypt’).
Comment 2 Marco Scardovi (scardracs) 2021-06-25 03:46:00 UTC
Sorry, the link contain a typo at the end, the correct one is https://gist.github.com/thesamesam/a36ff15235f5cbe5004972f80f254123
Comment 3 Marco Scardovi (scardracs) 2021-06-25 15:09:04 UTC
Created attachment 719256 [details]
genkernel.log.xz

This is the failed genkernel running with libxcrypt
Comment 4 Marco Scardovi (scardracs) 2021-06-25 15:10:38 UTC
(In reply to Thomas Deutschmann from comment #1)
> I tried to reproduce on a fully converted system but failed (which makes
> sense if new libxcrypt is a drop-in replacement). Furthermore, default
> busybox built by genkernel doesn’t even link against crypt.
> 
> The only failure I was able to force was in util-linux when forcefully
> deleting libxcrypt headers (=putting system into broken state).
> 
> Therefore I am currently suspecting that this bug report is invalid (i.e.
> problem was seen on a not fully converted system) and requesting full logs
> (genkernel.log & `energe —info sys-lib/glibc libxcrypt’).

This is the emerge info you have requested

Portage 3.0.20 (python 3.10.0-beta-3, default/linux/amd64/17.1/desktop/plasma/systemd, gcc-11.1.0, glibc-2.33-r1, 5.12.13-gentoo-x86_64 x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-5.12.13-gentoo-x86_64-x86_64-AMD_Ryzen_3_3200U_with_Radeon_Vega_Mobile_Gfx-with-glibc2.33
KiB Mem:    14304936 total,   4241156 free
KiB Swap:          0 total,         0 free
Timestamp of repository gentoo: Fri, 25 Jun 2021 02:21:37 +0000
Head commit of repository gentoo: 57a30e6f5a59615c1c08d926430ccba453bfd3b1

Head commit of repository guru: 06ec17ea7f6af238f0cea9451aa5ad71addd34f0

sh bash 5.1_p8
ld GNU ld (Gentoo 2.36.1 p3) 2.36.1
distcc 3.4 x86_64-pc-linux-gnu [disabled]
app-shells/bash:          5.1_p8::gentoo
dev-java/java-config:     2.3.1::gentoo
dev-lang/perl:            5.34.0::gentoo
dev-lang/python:          3.9.5_p2::gentoo, 3.10.0_beta3::gentoo
dev-lang/rust-bin:        1.53.0::gentoo
dev-util/cmake:           3.20.5::gentoo
sys-apps/baselayout:      2.7-r3::gentoo
sys-apps/sandbox:         2.24::gentoo
sys-devel/autoconf:       2.13-r1::gentoo, 2.69-r5::gentoo
sys-devel/automake:       1.16.3-r1::gentoo
sys-devel/binutils:       2.36.1-r1::gentoo
sys-devel/gcc:            11.1.0-r1::gentoo
sys-devel/gcc-config:     2.4::gentoo
sys-devel/libtool:        2.4.6-r6::gentoo
sys-devel/make:           4.3::gentoo
sys-kernel/linux-headers: 5.12::gentoo (virtual/os-headers)
sys-libs/glibc:           2.33-r1::gentoo
Repositories:

gentoo
    location: /srv/gentoo
    sync-type: git
    sync-uri: https://github.com/gentoo-mirror/gentoo.git
    priority: -1000
    sync-git-clone-extra-opts: -b master

guru
    location: /srv/guru
    sync-type: git
    sync-uri: https://anongit.gentoo.org/git/repo/proj/guru.git/
    masters: gentoo
    sync-git-clone-extra-opts: -b master

local
    location: /srv/local
    masters: gentoo

crossdev
    location: /srv/localrepo-crossdev
    masters: gentoo
    priority: 10

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -march=znver1 -fdiagnostics-color=always -frecord-gcc-switches"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/config /usr/share/gnupg/qualified.txt /var/qmail/alias /var/qmail/control"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -pipe -march=znver1 -fdiagnostics-color=always"
DISTDIR="/srv/cache/"
ENV_UNSET="CARGO_HOME DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN GOPATH PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe -march=znver1 -fdiagnostics-color=always"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict network-sandbox news parallel-fetch pid-sandbox preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms strict strict-keepdir unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe -march=znver1 -fdiagnostics-color=always"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="it_IT.UTF-8"
LDFLAGS="-O2 -pipe -march=znver1 -fdiagnostics-color=always -Wl,-O1 -Wl,--defsym=__gentoo_check_ldflags__=0 -Wl,--as-needed"
MAKEOPTS="-j5 -l10"
PKGDIR="/srv/cache/"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 aac acl acpi activities alsa amd64 berkdb bluetooth branding bzip2 cairo cdda cdr cli colord crypt cups dbus declarative dri dts dvd dvdr emboss encode exif flac fortran gdb gdbm gentoo-dev gif gles2 gpm grub gui iconv icu ipv6 jpeg kde kipi kwallet lcms libglvnd libnotify libtirpc mad mng mp3 mp4 mpeg mtp multilib ncurses nls nptl ogg opengl openmp pam pango pcre pdf phonon pipewire-alsa plasma png policykit ppds pulseaudio python qml qt5 readline screencast sdl seccomp semantic-desktop spell split-usr ssl startup-notification svg systemd tcpd tiff truetype udev udisks unicode upower usb vorbis wayland widgets wxwidgets x264 xattr xcb xml xv xvid zlib" ABI_X86="64" ADA_TARGET="gnat_2018" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx avx2 f16c fma3 mmx mmxext pclmul popcnt rdrand sha sse sse2 sse3 sse4_1 sse4_2 sse4a ssse3" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="efi-64" INPUT_DEVICES="libinput" KERNEL="linux" L10N="it en" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LUA_SINGLE_TARGET="lua5-1" LUA_TARGETS="lua5-1" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-3 php7-4" POSTGRES_TARGETS="postgres10 postgres11" PYTHON_SINGLE_TARGET="python3_9" PYTHON_TARGETS="python3_9 python3_10" RUBY_TARGETS="ruby26" USERLAND="GNU" VIDEO_CARDS="amdgpu radeonsi" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq proto steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, LINGUAS, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, RUSTFLAGS

=================================================================
                        Package Settings
=================================================================

sys-libs/glibc-2.33-r1::gentoo was built with the following:
USE="multiarch (multilib) (static-libs) -audit -caps (-cet) -compile-locales -crypt -custom-cflags -doc -gd -headers-only -multilib-bootstrap -nscd -profile (-selinux) -ssp -static-pie -suid -systemtap -test (-vanilla)" ABI_X86="(64)"
CFLAGS="-pipe -march=znver1 -fdiagnostics-color=always -O2"
CXXFLAGS="-pipe -march=znver1 -fdiagnostics-color=always -O2"
FEATURES="merge-sync multilib-strict xattr fixlafiles binpkg-dostrip usersync strict qa-unresolved-soname-deps assume-digests strict-keepdir usersandbox binpkg-logs sandbox distlocks userpriv unmerge-orphans parallel-fetch config-protect-if-modified pid-sandbox binpkg-docompress news ipc-sandbox sfperms preserve-libs protect-owned unknown-features-warn unmerge-logs userfetch ebuild-locks network-sandbox"
LDFLAGS="-pipe -march=znver1 -fdiagnostics-color=always -Wl,-O1 -Wl,--defsym=__gentoo_check_ldflags__=0 -Wl,--as-needed"


sys-libs/libxcrypt-4.4.23::gentoo was built with the following:
USE="compat system (-split-usr) -static-libs -test" ABI_X86="(64) -32 (-x32)"
FEATURES="merge-sync multilib-strict xattr fixlafiles binpkg-dostrip usersync strict qa-unresolved-soname-deps assume-digests strict-keepdir usersandbox binpkg-logs sandbox distlocks userpriv unmerge-orphans parallel-fetch config-protect-if-modified pid-sandbox binpkg-docompress news ipc-sandbox sfperms preserve-libs protect-owned unknown-features-warn unmerge-logs userfetch ebuild-locks network-sandbox"
Comment 5 Thomas Deutschmann gentoo-dev Security 2021-06-25 15:37:44 UTC
Only happening when system uses sys-libs/libxcrypt[-static-libs]. Note that glibc is forcing static-libs and libxcrypt has USE=static-libs by default enabled.
Comment 6 Larry the Git Cow gentoo-dev 2021-07-06 00:25:12 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/proj/genkernel.git/commit/?id=8fa4d682493e704cfdea5c51aecc26af868e9d97

commit 8fa4d682493e704cfdea5c51aecc26af868e9d97
Author:     Thomas Deutschmann <whissi@gentoo.org>
AuthorDate: 2021-07-05 22:36:00 +0000
Commit:     Thomas Deutschmann <whissi@gentoo.org>
CommitDate: 2021-07-05 23:40:51 +0000

    defaults/software.sh: Add libxcrypt
    
    Needed for BusyBox when host system is using sys-libs/libxcrypt[-static-libs]
    which is usually enforced via package.use.force.
    
    Bug: https://bugs.gentoo.org/798468
    Signed-off-by: Thomas Deutschmann <whissi@gentoo.org>

 defaults/software.sh       |  9 ++++++++-
 gkbuilds/libxcrypt.gkbuild | 17 +++++++++++++++++
 2 files changed, 25 insertions(+), 1 deletion(-)
Comment 7 Sam James archtester gentoo-dev Security 2021-07-15 03:49:09 UTC
This is fixed in 4.2.3, I think?
Comment 8 Marco Scardovi (scardracs) 2021-07-15 04:51:26 UTC
I've not tried it so i don't know
Comment 9 Thomas Deutschmann gentoo-dev Security 2021-07-15 11:21:37 UTC
Yes, fixed in v4.2.3.